<?php

#
# i-scream central monitoring system
# http://www.i-scream.org
# Copyright (C) 2000-2002 i-scream
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

# Navigation for the i-scream reports.
# pjm2@ukc.ac.uk
#
# CONFIGURABLE CONSTANTS: -

include("latest_config.inc.php");

#
# END CONFIGURATION

include("iutils.inc.php");

function printLine($title) {
    echo "<hr style=\"color:#9999ff;\">";
    echo "<b>$title</b>";
}


function showStat($title, $value, $input, $graph="") {

    $report = $value;

    $value = getPregMatch($value, $input);
    if (!isset($value)) {
        $value = "<i><font color=\"#999999\">not sent</font></i>";
    }
    ?>
        <table border="0" width="100%">
          <tr>
            <td width="50%" align="right" valign="top">
             <b><?=$title?></b>
            </td>
            <td width="50%" align="left" valign="top">
             <? if (preg_match("/^[0-9]+\.?[0-9]*$/", $value)) {
                    linkToHistory($graph);
                } ?> 
              <?=$value?></td>
          </tr>
        </table>
    <?
}


function linkToHistory($graph) {
    global $machine;
    if(!empty($graph)) {
        echo <<<EOT
        <a href="graphs.php?machine_name=$machine&graph=$graph&submit=Show"><img src="minichart.gif" alt="View historical graphs of this data" width="20" height="20" border="0"></a>
EOT;
    }
}


# show all disk information.
function showDisks($diskRoot, $units, $input) {
    include("latest_config.inc.php");

    $i = 0;
    while(1) {
        $name = getPregMatch("$diskRoot.p$i.attributes.name", $input);
        $mount = getPregMatch("$diskRoot.p$i.attributes.mount", $input);
        if ($name || $mount) {
            $used = "$diskRoot.p$i.attributes.used";
            $total = "$diskRoot.p$i.attributes.total";
            $graph = preg_replace("/_/", "$hex_underscore", $mount);
            $graph = preg_replace("/\//", "$hex_slash", $graph);
            $totalinodes = getPregMatch("$diskRoot.p$i.attributes.totalinodes", $input);
            $freeinodes = getPregMatch("$diskRoot.p$i.attributes.freeinodes", $input);
            showBar("$name ($mount)<br>space used", $used, $total, $units, $input, "disk-$graph");
            showBar("inodes used", (int) $freeinodes, (int) $totalinodes, " inodes", $input, "", "swap");
            print "          <br><br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# show all disk IO information.
function showDiskIO($diskRoot, $input) {
    include("latest_config.inc.php");
 
    $i = 0;
    while(1) {
        $name = getPregMatch("$diskRoot.p$i.attributes.name", $input);
        if ($name) {
            print "<br><center><b>(Disk $name)</b></center>";
            showStat("Read bytes (per sec)", "$diskRoot.p$i.attributes.rbytes", $input, "diskio-$name");
            showStat("Write bytes (per sec)", "$diskRoot.p$i.attributes.wbytes", $input, "diskio-$name");
            print "          <br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# show all network information.
function showNet($netRoot, $input) {
    include("latest_config.inc.php");
                                                                                
    $i = 0;
    while(1) {
        $name = getPregMatch("$netRoot.p$i.attributes.name", $input);
        if ($name) {
            print "<br><center><b>(Network Interface $name)</b></center>";
            showStat("Received bytes (per sec)", "$netRoot.p$i.attributes.rx", $input, "net-$name");
            showStat("Transfered bytes (per sec)", "$netRoot.p$i.attributes.tx", $input, "net-$name");
            print "          <br>\n";
        }
        else {
            break;
        }
        $i++;
    }
}


# Return a preg_match result.
function getPregMatch($value, $input) {
    preg_match("/$value=([^\,\}]*)[\,\}]/", $input, $matches);
    return $matches[1];
}


# show a bar-represented value.
function showBar($title, $value, $max, $units, $input, $graph="", $arrange='normal') {

    include("latest_config.inc.php");

    $report = $value;
    if (!is_int($value)) {
        $value = getPregMatch($value, $input);
    }
    if (!is_int($max)) {
        $max = getPregMatch($max, $input);
    }
    if (!isset($value) || !isset($max)) {
        return;
    }

    if ($arrange == 'swap') {
        $value = $max - $value;
    }

    if(empty($max)) {
        $width = 1;
    }
    else {
        $width = intval($max_width * $value / $max);
        if ($width < 1) {
            $width = 1;
        }
    }

    ?>
        <table border="0" cellpadding="0" cellspacing="0" align="center">
          <tr>
            <td colspan="2"><? linkToHistory($graph); ?> <b><?=$title?></b> <font size="2">(<?=$value?><?=$units?>)</font></td>
          </tr>
          <tr>
            <td colspan="2" bgcolor="#eeeeff"><img src="<?=$barImage?>" border="0" height="20" width="<?=$width?>"></td>
          </tr>
          <tr>
            <td colspan="2"><img src="<?=$scaleImage?>" border="0" height="11" width="<?=$max_width?>"></td>
          </tr>
          <tr>
            <td align="left">0<?=$units?></td>
            <td align="right"><?=$max?><?=$units?></td>
          </tr>
        </table>
    <?
}


?>

<? include($titleHTML); ?>

<? printLine("Display the latest information received from a host"); ?>

<form method="<? echo $formMethod ?>" action="<? echo $thisPage ?>">
<?

    $file_array = getdirArray($latestDirectory,'asort');
    print "<select size=\"1\" name=\"machine\">";
    if ($machine) { ?>
        <option selected value="<? echo $machine ?>"><? echo $machine ?></option>
        <option value="">----------------</option>
    <? }
    foreach($file_array as $file_name) {
        #if (is_dir($file_name)) {
            print "<option value=\"$file_name\">$file_name</option>";
        #}
    }
    print "</select>";

?>
 <input type="submit" name="submit" value="Display">
</form>

<? if ($machine) {

       $last_modified = filemtime("$latestDirectory/$machine/$latestData");
       clearstatcache();
       $data_age = time() - $last_modified;

       $last_modified = date("l jS F Y - g:ia", $last_modified);

       if ($data_age > $warning_age) {
           $warning = <<<EOT
               <br>
               <font color="red"><b>
                   Warning:
               </b></font>
                   This realtime report is too old to be considered recent
EOT;
       }

echo <<<EOT
       <table border="0" bgcolor="#000066" cellpadding="3" cellspacing="1">
         <tr>
           <td bgcolor="#000066">
             &nbsp;
           </td>
           <td bgcolor="#ffffcc">
             <font face="arial,sans-serif" size="2">
               <b>Receipt date:</b> $last_modified
               $warning
             </font>
           </td>
         </tr>
       </table>
EOT;

       # Read the file.
       if (file_exists("$latestDirectory/$machine/$latestData")) {
           $input = file("$latestDirectory/$machine/$latestData");
           # All we need is the first line if there is more than one line.
           $input = $input[0];
       }

       if (!isset($input)) {
           echo "<br><br>There are currently no latest details about <b>$machine</b>.  Please notify your i-scream server administrator if you believe this to be incorrect.";
       }
       else {
           # Display the data specified in the display include.
           include("latest_display.inc.php");
       }
   }

?>

<? printLine(""); ?>

<? include($bottomHTML); ?>
